#ifndef _CACHE_H_
#define _CACHE_H_

#ifdef __cplusplus
extern "C" {
#endif

#define L1_SIZE_0K  0
#define L1_SIZE_4K  1
#define L1_SIZE_8K  2
#define L1_SIZE_16K 3
#define L1_SIZE_32K 4

#define L2_SIZE_0K   0
#define L2_SIZE_32K  1
#define L2_SIZE_64K  2
#define L2_SIZE_128K 3
#define L2_SIZE_256K 4

#define CACHEABLE_OFF 0
#define CACHEABLE_ON 1

#define CACHE_0_REGS 0x01840000u

#define L1PCFG (*(volatile unsigned int*)(CACHE_0_REGS+0x20))
#define L1DCFG (*(volatile unsigned int*)(CACHE_0_REGS+0x40))
#define L2CFG  (*(volatile unsigned int*)CACHE_0_REGS)

#define L1DWB  (*(volatile unsigned int*)(CACHE_0_REGS+0x5040))
#define L2WB  (*(volatile unsigned int*)(CACHE_0_REGS+0x5000))

#define MAR192 (*(volatile unsigned int*)0x01848300) /* SDRAM */
#define MAR193 (*(volatile unsigned int*)0x01848304)

#define MAR96  (*(volatile unsigned int*)0x01848180) /* LCD */
#define MAR17  (*(volatile unsigned int*)0x01848044) /* L2 */

static inline void L1D_WriteBack(void) //Flush L1D
{
 L1DWB=0x00000001;
 while(L1DWB&0x00000001);
}

static inline void L2_WriteBack(void)  //Flush L2
{
 L2WB=0x00000001;
 while(L2WB&0x00000001);
}

void L1P_Config(unsigned int c);
void L1D_Config(unsigned int c);
void L2_Config(unsigned int c);
void SDRAM_Cacheable(unsigned int c);

#ifdef __cplusplus
}
#endif

#endif
