#include "EDMA3.h"

#define IDX_MAX 32767
#define CNT_MAX 65535

void EDMA3_Init(void *s,u32 n)
{
 register u32 A=n,B=1;

 while(1)
 {
  if((A<=IDX_MAX)&&(B<=CNT_MAX)&&(!(n%B)))break;
  B++;
  A=n/B;
 }

 EDMA3_ESR=0x00000000;                   //Channel 0 event clear
 EDMA3_ICR=0x00000001;                   //Channel 0 interrupt clear

 PaRAM_OPT=0;
 PaRAM_SRC=(u32)s;                       //SRC Address
 PaRAM_A_CNT=(u16)A;                     //1..65535
 PaRAM_B_CNT=(u16)B;                     //1..65535
 PaRAM_DST=LCD_D;                        //DST Address (LCD Data Port)
 PaRAM_SRC_BIDX=(u16)A;                  //-32786..32767
 PaRAM_DST_BIDX=0;
 PaRAM_LINK=0xFFFF;
 PaRAM_BCNTRLD=0;
 PaRAM_SRC_CIDX=0;
 PaRAM_DST_CIDX=0;
 PaRAM_CCNT=1;
 PaRAM_RSVD=0;
 PaRAM_OPT=(1<<20)|(1<<3)|(1<<2)|(1<<1)|(5<<8); //TCINTEN=1, STATIC=1, SYNCDIM=1, DAM=1, FIFO width 256 bit
}

void EDMA_Wait(void)
{
 static u32 first=1;
 if(first)first=0;
 else                                    //    DMA
 {
  while(!(EDMA3_IPR&0x00000001));        //Channel 0 interrupt pending
  EDMA3_ICR=0x00000001;                  //Channel 0 interrupt clear
 }
}

//128x128 682 FPS
void EDMA3_Run(void)
{
 EDMA3_ESR=0x00000001;                   //Channel 0 set
}

void EDMA3_SRC(void *s)
{
 PaRAM_SRC=(u32)s;                       //SRC Address
}
