#ifndef _EDMA3_H_
#define _EDMA3_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "Type.h"

#include "EMIFA.h"

#define EDMA3_ESR (*(IO u32*)0x01C01010) /* Event Set Register         */
#define EDMA3_IPR (*(IO u32*)0x01C01068) /* Interrupt Pending Register */
#define EDMA3_ICR (*(IO u32*)0x01C01070) /* Interrupt Clear Register   */

#define PaRAM_BASE 0x01C04000

#define PaRAM_OPT       (*(IO u32*)(PaRAM_BASE+0x0000))
#define PaRAM_SRC       (*(IO u32*)(PaRAM_BASE+0x0004))

#define PaRAM_A_CNT     (*(IO u16*)(PaRAM_BASE+0x0008))
#define PaRAM_B_CNT     (*(IO u16*)(PaRAM_BASE+0x000A))

#define PaRAM_DST       (*(IO u32*)(PaRAM_BASE+0x000C))

#define PaRAM_SRC_BIDX  (*(IO u16*)(PaRAM_BASE+0x0010))
#define PaRAM_DST_BIDX  (*(IO u16*)(PaRAM_BASE+0x0012))

#define PaRAM_LINK      (*(IO u16*)(PaRAM_BASE+0x0014))
#define PaRAM_BCNTRLD   (*(IO u16*)(PaRAM_BASE+0x0016))

#define PaRAM_SRC_CIDX  (*(IO u16*)(PaRAM_BASE+0x0018))
#define PaRAM_DST_CIDX  (*(IO u16*)(PaRAM_BASE+0x001A))

#define PaRAM_CCNT      (*(IO u16*)(PaRAM_BASE+0x001C))
#define PaRAM_RSVD      (*(IO u16*)(PaRAM_BASE+0x001E))

void EDMA3_Init(void *s,u32 n);
void EDMA_Wait(void);
void EDMA3_Run(void);
void EDMA3_SRC(void *s);

#ifdef __cplusplus
}
#endif

#endif
