#ifndef _EMIFA_H_
#define _EMIFA_H_

#ifdef __cplusplus
extern "C" {
#endif

#define LCD_BASE 0x60000000     /* 32MB Async Data (CS2) */

#define LCD_I  LCD_BASE
#define LCD_D (LCD_BASE+0x00004000) /* A12 */

#define LCD_I8 (*(volatile unsigned char*)LCD_I)
#define LCD_D8 (*(volatile unsigned char*)LCD_D)

#define LCD_I16 (*(volatile unsigned short int*)LCD_I)
#define LCD_D16 (*(volatile unsigned short int*)LCD_D)

#define LCD_I32 (*(volatile unsigned int*)LCD_I)
#define LCD_D32 (*(volatile unsigned int*)LCD_D)

#define LCD_I64 (*(volatile unsigned long long*)LCD_I)
#define LCD_D64 (*(volatile unsigned long long*)LCD_D)

#define EMIFA_BASE              0x68000000

#define EMIFA_MIDR   (*(volatile unsigned int*)(EMIFA_BASE     )) /* Module ID Register */
#define EMIFA_CE2CFG (*(volatile unsigned int*)(EMIFA_BASE+0x10)) /* Asynchronous 1 Configuration Register */

void EMIFA_Init(void);

#ifdef __cplusplus
}
#endif

#endif
