#include "S6D04D1X21.h"

void Delay(volatile u32 ms) //for 456 MHz
{
 volatile u32 i;
 while(ms>0)
 {
  for(i=0;i<32775;i++);
  ms--;
 }
}

void LCD_Reset(void)
{
 GPIO_DIR23=~(1<<16);   //out   GP3[0]

 GPIO_SET_DATA23=1<<16; //set   GP3[0]
 Delay(10);

 GPIO_CLR_DATA23=1<<16; //clear GP3[0]
 Delay(100);

 GPIO_SET_DATA23=1<<16; //set   GP3[0]
 Delay(10);
}

void LCD_Init(void)
{
 LCD_WR_REG(0xe0);
 LCD_WR_DAT(0x01); 

 LCD_WR_REG(0xf3);
 LCD_WR_DAT(0x00); 

 LCD_WR_REG(0xf1);
 LCD_WR_DAT(0x5a); 
 
 LCD_WR_REG(0xff); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x40); 
 Delay(10); 
 
 LCD_WR_REG(0xff); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x78); 
 
 LCD_WR_REG(0x11); 
 Delay(100); 
 
 LCD_WR_REG(0xfd); 
 LCD_WR_DAT(0x02); 
 LCD_WR_DAT(0x01); 
 
 LCD_WR_REG(0xf2); 
 LCD_WR_DAT(0x10); 
 LCD_WR_DAT(0x10); 
 LCD_WR_DAT(0x01); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(/*0x04*/ 0x00); //Non- odd/even frame 
 LCD_WR_DAT(0x1a); 
 LCD_WR_DAT(0x1a); 
 
 LCD_WR_REG(0xf3); 
 LCD_WR_DAT(0x01); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x0c); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x75); 
 LCD_WR_DAT(0x75); 
 LCD_WR_DAT(0x30); 
 
 LCD_WR_REG(0xf4); 
 LCD_WR_DAT(0x59);//5e 
 LCD_WR_DAT(0x59);//5e 
 LCD_WR_DAT(0x52); 
 LCD_WR_DAT(0x52); 
 LCD_WR_DAT(0x11); 
 
 LCD_WR_REG(0xf5); 
 LCD_WR_DAT(0x12); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x0b); 
 LCD_WR_DAT(0xf0); 
 LCD_WR_DAT(0x00); 
 Delay(30); 
 
 LCD_WR_REG(0xf3); 
 LCD_WR_DAT(0x03); 
 Delay(30); 
 
 LCD_WR_REG(0xff); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x40); 
 Delay(30); 
 
 LCD_WR_REG(0xf3); 
 LCD_WR_DAT(0x07); 
 Delay(30); 
 
 LCD_WR_REG(0xf3); 
 LCD_WR_DAT(0x1f); 
 Delay(50); 
 
 LCD_WR_REG(0xf3); 
 LCD_WR_DAT(0x3f); 
 Delay(30); 
 
 LCD_WR_REG(0xf3); 
 LCD_WR_DAT(0xff); 
 
 LCD_WR_REG(0xf6); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(/*0x10*/ 0x18); //Endian
 LCD_WR_DAT(0x00); 
 
 LCD_WR_REG(0xf7); 
 LCD_WR_DAT(0x0d); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x0e); 
 LCD_WR_DAT(0x1d); 
 LCD_WR_DAT(0x26); 
 LCD_WR_DAT(0x2b); 
 LCD_WR_DAT(0x32); 
 LCD_WR_DAT(0x10); 
 LCD_WR_DAT(0x13); 
 LCD_WR_DAT(0x29); 
 LCD_WR_DAT(0x23); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x22); 
 LCD_WR_DAT(0x22); 
 
 LCD_WR_REG(0xf8); 
 LCD_WR_DAT(0x0d); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x0e); 
 LCD_WR_DAT(0x1d); 
 LCD_WR_DAT(0x26); 
 LCD_WR_DAT(0x2b); 
 LCD_WR_DAT(0x32); 
 LCD_WR_DAT(0x10); 
 LCD_WR_DAT(0x13); 
 LCD_WR_DAT(0x29); 
 LCD_WR_DAT(0x23); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x22); 
 LCD_WR_DAT(0x22); 
 
 LCD_WR_REG(0xf9); 
 LCD_WR_DAT(0x1e); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x0a); 
 LCD_WR_DAT(0x19); 
 LCD_WR_DAT(0x23); 
 LCD_WR_DAT(0x2e); 
 LCD_WR_DAT(0x35); 
 LCD_WR_DAT(0x3d); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x05); 
 LCD_WR_DAT(0x19); 
 LCD_WR_DAT(0x14); 
 LCD_WR_DAT(0x07); 
 LCD_WR_DAT(0x22); 
 LCD_WR_DAT(0x22); 
 
 LCD_WR_REG(0xfa); 
 LCD_WR_DAT(0x0d); 
 LCD_WR_DAT(0x11); 
 LCD_WR_DAT(0x0a); 
 LCD_WR_DAT(0x19); 
 LCD_WR_DAT(0x23); 
 LCD_WR_DAT(0x2e); 
 LCD_WR_DAT(0x35); 
 LCD_WR_DAT(0x3d); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x05); 
 LCD_WR_DAT(0x19); 
 LCD_WR_DAT(0x14); 
 LCD_WR_DAT(0x07); 
 LCD_WR_DAT(0x22); 
 LCD_WR_DAT(0x22); 
 
 LCD_WR_REG(0xfb); 
 LCD_WR_DAT(0x0d); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x0e); 
 LCD_WR_DAT(0x1d); 
 LCD_WR_DAT(0x26); 
 LCD_WR_DAT(0x2b); 
 LCD_WR_DAT(0x32); 
 LCD_WR_DAT(0x10); 
 LCD_WR_DAT(0x13); 
 LCD_WR_DAT(0x29); 
 LCD_WR_DAT(0x23); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x22); 
 LCD_WR_DAT(0x22); 
 
 LCD_WR_REG(0xfc); 
 LCD_WR_DAT(0x0d); 
 LCD_WR_DAT(0x00); 
 LCD_WR_DAT(0x03); 
 LCD_WR_DAT(0x0e); 
 LCD_WR_DAT(0x1d); 
 LCD_WR_DAT(0x26); 
 LCD_WR_DAT(0x2b); 
 LCD_WR_DAT(0x32); 
 LCD_WR_DAT(0x10); 
 LCD_WR_DAT(0x13); 
 LCD_WR_DAT(0x29); 
 LCD_WR_DAT(0x23); 
 LCD_WR_DAT(0x08); 
 LCD_WR_DAT(0x22); 
 LCD_WR_DAT(0x22); 
 
 LCD_WR_REG(0xfd); 
 LCD_WR_DAT(0x11); 
 LCD_WR_DAT(0x01); 
 
 LCD_WR_REG(0x35); 
 LCD_WR_DAT(0x00); 
 
 LCD_WR_REG(0x36); 
 LCD_WR_DAT(/*0x48*/ 0x28); //Orientation 
 
 LCD_WR_REG(0x3a); 
 LCD_WR_DAT(0x55); 
 
 LCD_WR_REG(0x29); 
 Delay(20); 
}

void LCD_Position(u16 sx,u16 sy,u16 ex,u16 ey)
{
 /* Column Address Set */
 LCD_WR_REG(0x2A);
 LCD_WR_DAT(sx>>8);
 LCD_WR_DAT(sx);
 LCD_WR_DAT(ex>>8);
 LCD_WR_DAT(ex);

 /* Page Address Set */
 LCD_WR_REG(0x2B);
 LCD_WR_DAT(sy>>8);
 LCD_WR_DAT(sy);
 LCD_WR_DAT(ey>>8);
 LCD_WR_DAT(ey);
 
 /* Memory Write */
 LCD_WR_REG(0x2C);
}

void LCD_Clear(u16 c)
{
 c=REV16(c);
 register u32 i=LCD_W*LCD_H;
 LCD_Position(0,0,LCD_H-1,LCD_W-1);
 while(i--)LCD_D16=c;
}

void LCD_Background(void)
{
 int n=sizeof(Background);
 u64 * restrict PS=(u64*)Background;
 u64 * restrict PD=(u64*)SwitchBuffer[0];
 _nassert((u32)PS%8==0);
 _nassert((u32)PD%8==0);
 _nassert(n>0);
 _nassert(n%8==0);
 #pragma MUST_ITERATE(8,,8)
 while((n-=8)>=0)_amem8(PD++)=_amem8(PS++);
}

//                   BLACK   BLUE    GREEN   CYAN    RED     MAGENTA YELLOW  WHITE
const u16 Colors[8]={0x0000, 0x001F, 0x07E0, 0x07FF, 0xF800, 0xF81F, 0xFFE0, 0xFFFF};

void LCD_Test(void)
{
 LCD_Position(0,0,LCD_H-1,LCD_W-1);
 for(u8 j=0;j<8;j++)
 {
  register u32 i=(LCD_W*LCD_H)/8;
  while(i--)LCD_D16=REV16(Colors[j]);
 }
}
