#include "Timer.h"

void Timer_Delay(u32 d)
{
 d*=24000;
 TIMER_TGCR=0x00000004;                 //reset TIMER12
 TIMER_TIM12=0;                         //reset count
 TIMER_PRD12=d-1;                       //period
 TIMER_TCR=0x00000040;                  //one shot mode
 TIMER_INTCTLSTAT=0x00000003;           //enable and clear interrupt flag
 TIMER_TGCR=0x00000005;                 //activate TIMER12
 while(!(TIMER_INTCTLSTAT&0x00000002)); //wait...
}

void Timer_INT_Init(u32 d)
{
 d*=24000;
 TIMER_TGCR=0x00000004;                 //reset TIMER12
 TIMER_TIM12=0;                         //reset count
 TIMER_PRD12=d-1;                       //period
 TIMER_TCR=0x00000080;                  //continuous mode

 INTMUX1=4;                             //Event #4 T64P0_TINT12 => INTSEL4

 ISTP=(u32)_intcVectorTable;            //set new Vector Table for Interrupt

 ICR=0xFFF0;                            //clear all interrupts, bits 4 thru 15

 IER=(1<<1)|(1<<4);                     //enable NMI, INT4 interrupts

 _enable_interrupts();

 TIMER_TGCR=0x00000005;                 //activate TIMER12
}

volatile u32 Timer_Flag=0;

interrupt void Timer_INT(void)
{
 Timer_Flag=1;
}
