#ifndef _TIMER_H_
#define _TIMER_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <c6x.h>

#include "Type.h"

#define TIMER_TIM12 (*(IO u32*)0x01C20010) /* Timer Counter Register 12     */
#define TIMER_TIM34 (*(IO u32*)0x01C20014) /* Timer Counter Register 34     */
#define TIMER_PRD12 (*(IO u32*)0x01C20018) /* Timer Period Register 12      */
#define TIMER_PRD34 (*(IO u32*)0x01C2001C) /* Timer Period Register 34      */
#define TIMER_TCR   (*(IO u32*)0x01C20020) /* Timer Control Register        */
#define TIMER_TGCR  (*(IO u32*)0x01C20024) /* Timer Global Control Register */
#define TIMER_REL12 (*(IO u32*)0x01C20034) /* Timer Reload Register 12      */
#define TIMER_REL34 (*(IO u32*)0x01C20038) /* Timer Reload Register 34      */

#define TIMER_INTCTLSTAT (*(IO u32*)0x01C20044) /* Timer Interrupt Control and Status Register */

#define INTMUX1 (*(IO u32*)0x01800104) /* Interrupt mux register 1 */

extern void _intcVectorTable(void);

extern volatile u32 Timer_Flag;

void Timer_Delay(u32 d);

void Timer_INT_Init(u32 d);

#ifdef __cplusplus
}
#endif

#endif
